<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelEntityTemplate Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelEntityTemplate Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelEntityTemplate" --><!-- doxytag: inherits="iBase" -->
<p>This is an entity template.  
 <a href="structiCelEntityTemplate.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="entitytpl_8h_source.html">physicallayer/entitytpl.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelEntityTemplate:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelEntityTemplate.png" usemap="#iCelEntityTemplate_map" alt=""/>
  <map id="iCelEntityTemplate_map" name="iCelEntityTemplate_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,115,24"/>
</map>
 </div></div>

<p><a href="structiCelEntityTemplate-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#ae0b4b111d1e0b30fd909fecab45882e2">AddClass</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> cls)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a class to this entity.  <a href="#ae0b4b111d1e0b30fd909fecab45882e2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#a4ce4b28d3043533bf9a88f0b0e2cce1b">AddMessage</a> (const char *msgid, <a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *params)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a message to be sent to the created behaviour.  <a href="#a4ce4b28d3043533bf9a88f0b0e2cce1b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelPropertyClassTemplate.html">iCelPropertyClassTemplate</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#ac47fe787a2379374ea60eb6fe3c5025b">CreatePropertyClassTemplate</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new property class template for this entity.  <a href="#ac47fe787a2379374ea60eb6fe3c5025b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#a1e92218b2c9390a23ce530e11f1a5dc1">GetBehaviour</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the behaviour for this template.  <a href="#a1e92218b2c9390a23ce530e11f1a5dc1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#a1ba93485bac47a92122aa3a29a96cedd">GetBehaviourLayer</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the layer for this template.  <a href="#a1ba93485bac47a92122aa3a29a96cedd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsSet.html">csSet</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#a80b3e69c956b839b328a1a24939cc982">GetClasses</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the set of classes for this entity.  <a href="#a80b3e69c956b839b328a1a24939cc982"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#acf81c0aaaf027783db9fb0dbd4422d65">GetName</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of this template.  <a href="#acf81c0aaaf027783db9fb0dbd4422d65"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#a6ad2194d5e574a7e901518ae89ead470">HasClass</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> cls)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if this entity belongs to some class.  <a href="#a6ad2194d5e574a7e901518ae89ead470"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#aceccd02f43b6dd7dd98f698341cf9f4a">QueryObject</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> for this entity template.  <a href="#aceccd02f43b6dd7dd98f698341cf9f4a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#aff21f1484e1dcb3db093423d0e03588f">RemoveClass</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> cls)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a class from this entity.  <a href="#aff21f1484e1dcb3db093423d0e03588f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#ab01c190812566b105f23b081cdcbdb96">SetBehaviour</a> (const char *layer, const char *behaviour)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the behaviour associated with this template.  <a href="#ab01c190812566b105f23b081cdcbdb96"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelEntityTemplate.html#ad7e62f9e9c0f99e7ede6edc8c0e37632">SetName</a> (const char *n)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of this template.  <a href="#ad7e62f9e9c0f99e7ede6edc8c0e37632"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is an entity template. </p>
<p>It can be used to create other entities. </p>

<p>Definition at line <a class="el" href="entitytpl_8h_source.html#l00041">41</a> of file <a class="el" href="entitytpl_8h_source.html">entitytpl.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ae0b4b111d1e0b30fd909fecab45882e2"></a><!-- doxytag: member="iCelEntityTemplate::AddClass" ref="ae0b4b111d1e0b30fd909fecab45882e2" args="(csStringID cls)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelEntityTemplate.html#ae0b4b111d1e0b30fd909fecab45882e2">iCelEntityTemplate::AddClass</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>cls</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a class to this entity. </p>
<p>A class is an application defined attribute which indicates to what the entity belongs. It can be something like 'weapon' or 'creature' or whatever the application desires. </p>

</div>
</div>
<a class="anchor" id="a4ce4b28d3043533bf9a88f0b0e2cce1b"></a><!-- doxytag: member="iCelEntityTemplate::AddMessage" ref="a4ce4b28d3043533bf9a88f0b0e2cce1b" args="(const char *msgid, iCelParameterBlock *params)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelEntityTemplate.html#a4ce4b28d3043533bf9a88f0b0e2cce1b">iCelEntityTemplate::AddMessage</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>msgid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *&#160;</td>
          <td class="paramname"><em>params</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a message to be sent to the created behaviour. </p>
<p>The parameters here support CEL_DATA_PARAMETER. Note that all messages will be sent after all properties and property classes are created. </p>

</div>
</div>
<a class="anchor" id="ac47fe787a2379374ea60eb6fe3c5025b"></a><!-- doxytag: member="iCelEntityTemplate::CreatePropertyClassTemplate" ref="ac47fe787a2379374ea60eb6fe3c5025b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelPropertyClassTemplate.html">iCelPropertyClassTemplate</a>* <a class="el" href="structiCelEntityTemplate.html#ac47fe787a2379374ea60eb6fe3c5025b">iCelEntityTemplate::CreatePropertyClassTemplate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new property class template for this entity. </p>

</div>
</div>
<a class="anchor" id="a1e92218b2c9390a23ce530e11f1a5dc1"></a><!-- doxytag: member="iCelEntityTemplate::GetBehaviour" ref="a1e92218b2c9390a23ce530e11f1a5dc1" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelEntityTemplate.html#a1e92218b2c9390a23ce530e11f1a5dc1">iCelEntityTemplate::GetBehaviour</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the behaviour for this template. </p>

</div>
</div>
<a class="anchor" id="a1ba93485bac47a92122aa3a29a96cedd"></a><!-- doxytag: member="iCelEntityTemplate::GetBehaviourLayer" ref="a1ba93485bac47a92122aa3a29a96cedd" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelEntityTemplate.html#a1ba93485bac47a92122aa3a29a96cedd">iCelEntityTemplate::GetBehaviourLayer</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the layer for this template. </p>

</div>
</div>
<a class="anchor" id="a80b3e69c956b839b328a1a24939cc982"></a><!-- doxytag: member="iCelEntityTemplate::GetClasses" ref="a80b3e69c956b839b328a1a24939cc982" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsSet.html">csSet</a>&lt;<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&gt;&amp; <a class="el" href="structiCelEntityTemplate.html#a80b3e69c956b839b328a1a24939cc982">iCelEntityTemplate::GetClasses</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the set of classes for this entity. </p>

</div>
</div>
<a class="anchor" id="acf81c0aaaf027783db9fb0dbd4422d65"></a><!-- doxytag: member="iCelEntityTemplate::GetName" ref="acf81c0aaaf027783db9fb0dbd4422d65" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelEntityTemplate.html#acf81c0aaaf027783db9fb0dbd4422d65">iCelEntityTemplate::GetName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the name of this template. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>A pointer to the name of this template. </dd></dl>

</div>
</div>
<a class="anchor" id="a6ad2194d5e574a7e901518ae89ead470"></a><!-- doxytag: member="iCelEntityTemplate::HasClass" ref="a6ad2194d5e574a7e901518ae89ead470" args="(csStringID cls)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelEntityTemplate.html#a6ad2194d5e574a7e901518ae89ead470">iCelEntityTemplate::HasClass</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>cls</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check if this entity belongs to some class. </p>

</div>
</div>
<a class="anchor" id="aceccd02f43b6dd7dd98f698341cf9f4a"></a><!-- doxytag: member="iCelEntityTemplate::QueryObject" ref="aceccd02f43b6dd7dd98f698341cf9f4a" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a>* <a class="el" href="structiCelEntityTemplate.html#aceccd02f43b6dd7dd98f698341cf9f4a">iCelEntityTemplate::QueryObject</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> for this entity template. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>A pointer to the <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> for this entity. </dd></dl>

</div>
</div>
<a class="anchor" id="aff21f1484e1dcb3db093423d0e03588f"></a><!-- doxytag: member="iCelEntityTemplate::RemoveClass" ref="aff21f1484e1dcb3db093423d0e03588f" args="(csStringID cls)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelEntityTemplate.html#aff21f1484e1dcb3db093423d0e03588f">iCelEntityTemplate::RemoveClass</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>cls</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a class from this entity. </p>

</div>
</div>
<a class="anchor" id="ab01c190812566b105f23b081cdcbdb96"></a><!-- doxytag: member="iCelEntityTemplate::SetBehaviour" ref="ab01c190812566b105f23b081cdcbdb96" args="(const char *layer, const char *behaviour)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelEntityTemplate.html#ab01c190812566b105f23b081cdcbdb96">iCelEntityTemplate::SetBehaviour</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>behaviour</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the behaviour associated with this template. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">layer</td><td>is the name of the behaviour layer (optional, can be 0 for default). </td></tr>
    <tr><td class="paramname">behaviour</td><td>is the name of the behaviour. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad7e62f9e9c0f99e7ede6edc8c0e37632"></a><!-- doxytag: member="iCelEntityTemplate::SetName" ref="ad7e62f9e9c0f99e7ede6edc8c0e37632" args="(const char *n)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelEntityTemplate.html#ad7e62f9e9c0f99e7ede6edc8c0e37632">iCelEntityTemplate::SetName</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the name of this template. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">n</td><td>A pointer to the name to set for this template. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="entitytpl_8h_source.html">entitytpl.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
